import axios from './boot/axios';

import endpoints from "./endpoints";
import utilities from "./utilities";

export default {

  async token_set(token) {

  },

  async token_verify(token) {

  },

  //de Sign/over
  //de TODO: Take destination URL to switch frontend applications, and remain authenticated.
  async token_transfer(token, url) {

  },

  //de Sign/up
  async register(dirty) {
    try {
      const payload = utilities.clean_payload(dirty)
      const response = await axios.post(endpoints.PARTICIPANT_REGISTER, payload)
      return response.data
    } catch(error) {
      console.warn(error)
      return null
    }
  },

  //de Sign/in
  async authenticate(credentials) {
    let response = await axios.post(endpoints.PARTICIPANT_AUTHENTICATE, credentials)
    if (response.data.tokens) {
      return {
        access: response.data.tokens.access,
        refresh: response.data.tokens.refresh,
      }
    }
    return null
  },

  //de Sign/out
  async invalidate () {
    try {
      let response = await axios.post(endpoints.PARTICIPANT_INVALIDATE)
      return response.data
    } catch (error) {
      //de console.warn(error)
      return null
    }
  },

  async password_forgot(email_address) {

  },

  async password_reset(email_address) {

  },

  //de TODO: Updating the store ought to periodically grab this data again.
  //de TODO: Down the line, here is where we would start using Web Sockets.

  async present(token) {
    try {
      let response = await axios.get(endpoints.PARTICIPANT_PRESENT)
      return response.data
    } catch(error) {
      console.warn(error)
      return null
    }
  }
}