import axios from './boot/axios';

function set_token_header(config) {
  console.log("set_token_header", config)
  return config
}

export default {
  //de set_token(token : string) {
  set_token(token) {
    //de console.log('set_token', token)
    axios.interceptors.request.use(set_token_header);
    //de console.log("set interceptor", axios)
    axios.defaults.headers.common['Authorization'] = `Bearer ${token}`;
    //de console.log('axios at set', axios.defaults)
  },

  clear_token () {
    //de console.log('clear_token')
    axios.interceptors.request.eject(set_token_header);
    axios.defaults.headers.common['Authorization'] = null;
  },

  clean_payload(dirty) {
    //de Clone object before mutating
    const payload = Object.assign({}, dirty);
    //de Remove empty values
    Object.keys(payload).forEach(k => (!payload[k] && payload[k] !== undefined) && delete payload[k]);
    return payload;
  }
}